(function (app) {
    var currentPage = 0;
    var iframeContainer;
    var maincontainer;
    var currentTabIndex;
    var innerWidth = $(window).innerWidth();
    var innerHeight = $(window).innerHeight();
    var lang;

    app.init = function () {
        var myLanguage = config.data.lang;
        // var myLanguage = undefined;
        if (typeof myLanguage == 'undefined')
            myLanguage = 'English';
        lang = LangConst.languages[myLanguage];
        // console.log(lang,"PPPPPPP");
        maincontainer = $('#maincontainer');
        maincontainer.empty();
        createObjects();
        MainActivity.setParameters();
        addEvents();
        addTabIndex();
        detectDevice();
        $('#pageIframe .titletext').focus();

        var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
        var eventer = window[eventMethod];
        var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";

        // Listen to message from child window
        eventer(messageEvent, function (e) {
            if (e.data == 'nextPage') {
                showNextPage(e);
            }
        }, false);

    }

    function createObjects() {
        // document.title = config.data.activity_name;
        iframeContainer = $('<iframe>', { 'id': 'pageIframe', 'class': 'tabindex', 'title': config.data.activity_name, 'style': 'clear:both;', 'src': 'pages/' + config.data.activity_pages[0] + '/index.html' });
        var clearDiv = $('<div>', { 'style': 'clear:both;' });
        bottomContainer = $('<div>', { class: 'bottom-container' });
        var navContainer = $('<div>', { class: 'nav-bar-container' });
        var navContainercontents = '<span class="nav-page-btn prev-nav-page"><a title="' + lang.previousPage + '" href="javascript:void(0);"><img alt="' + lang.previousPage + '" src="images/arrow_left_activity.svg" /></a></span>';
        navContainercontents += '<ul class="pagination">';
        var classActive = '';
        for (var i = 0; i < config.data.activity_pages.length; i++) {
            var displayI = parseInt(i) + 1;
            classActive = '';
            if (i == 0)
                classActive = 'active';
            navContainercontents += '<li data-page="' + i + '" class="nav-page nav-page' + i + ' ' + classActive + '"><a href="javascript:void(0);" aria-label="Page' + displayI + '">' + displayI + '</a></li>';
        }
        navContainercontents += '</ul><span class="nav-page-btn next-nav-page tabindex"><a href="javascript:void(0);" title="' + lang.nextPage + '"><img alt="' + lang.nextPage + '" src="images/arrow_right_activity.svg" /></a></span>';
        navContainer.append(navContainercontents);

        currentPage = localStorage.getItem('current_activity_page');
        if (currentPage == null || currentPage > config.data.activity_pages.length)
            currentPage = 1;
        currentPage = currentPage - 1;
        iframeContainer.attr('src', 'pages/' + config.data.activity_pages[currentPage] + '/index.html');

        maincontainer.append(iframeContainer);
        maincontainer.append(clearDiv);

        bottomContainer.append(navContainer);
        maincontainer.append(bottomContainer);
        $(".answer-container .headerFrame0").show();
        fnCheckNextBack();
    }
    function addEvents() {
        $('.nav-page').unbind().bind('click keypress', showPage);
        $('.next-nav-page').unbind().bind('click keypress', showNextPage);
        $('.prev-nav-page').unbind().bind('click keypress', showPreviousPage);
        setTimeout(function () {
            if ('ontouchstart' in window) {
                iframe = document.getElementById('pageIframe');
                innerDoc = iframe.contentDocument || iframe.contentWindow.document;
                $(innerDoc).find('textarea,input').unbind('focus').bind('focus', function () {
                    //$('.bottom-container').css('position', 'relative');
                });
                $(innerDoc).find('textarea,input').unbind('blur').bind('blur', function () {
                    //$('.bottom-container').css('position', 'fixed');
                })
            }
        }, 800);
    }
    function randomString(len) {
        var text = "";
        if (typeof len == 'undefined')
            len = 5;
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        for (var i = 0; i < len; i++)
            text += possible.charAt(Math.floor(Math.random() * possible.length));
        return text;
    }
    function showPage(e) {
        if (e.type === 'keypress' && (e.keyCode !== 13 && e.keyCode !== 32))
            return false;
        if ($(this).hasClass('active'))
            return false;
        var datapage = $(this).attr('data-page');
        currentPage = parseInt(datapage);
        var displayPage = currentPage + 1;
        var dataId = randomString(6);
        var iframe_src = 'pages/' + config.data.activity_pages[currentPage] + '/index.html?key=' + dataId;
        $('#pageIframe').attr('src', iframe_src);
        fnCheckNextBack();
        addTabIndex();
        $('#pageIframe').focus();
        addEvents();
        /* setTimeout(function(){
             document.title = document.getElementById("pageIframe").contentDocument.title;      
         }, 500);*/
        $('.next-nav-page').attr('tabindex', '-1');
        $('.prev-nav-page').attr('tabindex', '-1');
        if (displayPage == $('.pagination li').length) {
            $('.next-nav-page a').attr('tabindex', '-1');
            $('.prev-nav-page a').attr('tabindex', '0');
        } else
            if (displayPage == 1) {
                $('.prev-nav-page a').attr('tabindex', '-1');
                $('.next-nav-page a').attr('tabindex', '0');

            } else {
                $('.prev-nav-page a').attr('tabindex', '0');
                $('.next-nav-page a').attr('tabindex', '0');
            }
    }
    function showNextPage(e) {
        if (e.type === 'keypress' && (e.keyCode !== 13 && e.keyCode !== 32))
            return false;
        var nextPage = currentPage + 1;
        var dataId = randomString(6);
        if (nextPage <= config.data.activity_pages.length) {
            var iframe_src = 'pages/' + config.data.activity_pages[nextPage] + '/index.html?key=' + dataId;
            $('#pageIframe').attr('src', iframe_src);
            currentPage++;
        }
        fnCheckNextBack();
        addTabIndex();
        $('#pageIframe').focus();
        addEvents();
        $('.next-nav-page').attr('tabindex', '-1');
        $('.prev-nav-page').attr('tabindex', '-1');
        if (nextPage == $('.pagination li').length) {
            $('.next-nav-page a').attr('tabindex', '-1');
            $('.prev-nav-page a').attr('tabindex', '0');
        } else
            if (nextPage == 1) {
                $('.prev-nav-page a').attr('tabindex', '-1');
                $('.next-nav-page a').attr('tabindex', '0');

            } else {
                $('.prev-nav-page a').attr('tabindex', '0');
                $('.next-nav-page a').attr('tabindex', '0');
            }
    }
    function showPreviousPage(e) {
        if (e.type === 'keypress' && (e.keyCode !== 13 && e.keyCode !== 32))
            return false;
        var previousPage = currentPage - 1;
        var dataId = randomString(6);
        if (previousPage >= 0) {
            var iframe_src = 'pages/' + config.data.activity_pages[previousPage] + '/index.html?key=' + dataId;
            $('#pageIframe').attr('src', iframe_src);
            currentPage--;
        }
        fnCheckNextBack();
        addTabIndex();
        $('#pageIframe').focus();
        addEvents();
        $('.next-nav-page').attr('tabindex', '-1');
        $('.prev-nav-page').attr('tabindex', '-1');
        if (previousPage == $('.pagination li').length) {
            $('.next-nav-page a').attr('tabindex', '-1');
            $('.prev-nav-page a').attr('tabindex', '0');
        } else
            if (previousPage == 1) {
                $('.prev-nav-page a').attr('tabindex', '-1');
                $('.next-nav-page a').attr('tabindex', '0');

            } else {
                $('.prev-nav-page a').attr('tabindex', '0');
                $('.next-nav-page a').attr('tabindex', '0');
            }
    }

    /*Activity Pages Arrow Next Previous */
    function EnableLeftArrow() {
        $(".prev-nav-page").removeClass("disabled").css({ "pointer-events": "auto", "cursor": "pointer" });
    }
    function DisableLeftArrow() {
        $(".prev-nav-page").addClass("disabled").css({ "pointer-events": "none", "cursor": "default" });
    }
    function EnableRightArrow() {
        $(".next-nav-page").removeClass("disabled").css({ "pointer-events": "auto", "cursor": "pointer" });
    }
    function DisableRightArrow() {
        $(".next-nav-page").addClass("disabled").css({ "pointer-events": "none", "cursor": "default" });
    }
    function fnCheckNextBack() {
        //console.log('currentPage', currentPage)
        if (currentPage == 0) {
            DisableLeftArrow();
            EnableRightArrow();
        } else if (currentPage == config.data.activity_pages.length - 1) {
            EnableLeftArrow();
            DisableRightArrow();
        } else {
            EnableLeftArrow();
            EnableRightArrow();
        }
        if (config.data.activity_pages.length == 1)
            DisableRightArrow();

        $('.nav-bar-container .nav-page').each(function () {
            $(this).removeClass('active');
            $(this).css({ "pointer-events": "auto", "cursor": "pointer" });
        });
        $('.nav-bar-container .nav-page' + currentPage).addClass('active');
        $('.nav-bar-container .nav-page' + currentPage).css({ "pointer-events": "none", "cursor": "default" });
    }
    function addTabIndex() {
        var tab_index = 1000;
        $(".tabindex:visible").each(function (index) {
            if ($(this).hasClass('disabled')) {
                $(this).removeAttr("tabindex");
            }
            else {
                $(this).attr("tabindex", tab_index);
                tab_index++;
            }
        });
    }
    function removeTabIndex() {
        $(".tabindex:visible").each(function (index) {
            $(this).attr("tabindex", -1);
        });
    }
    app.setParameters = function () {
        var innerWidth = $(window).innerWidth();
        if ((innerWidth > 0) && (innerWidth <= 680)) {

        }
        else if ((innerWidth > 680) && (innerWidth <= 1000)) {

        }
        else {

        }


        //alert(iframeheight)
        setTimeout(function () {
            var iframeheight = $(window).innerHeight() - $('.bottom-container').height();
            if (iframeheight < 200)
                iframeheight = 200;

            $('#pageIframe').css({ 'height': iframeheight + 'px' });
        }, 100);
    }
    function detectDevice() {
        var screenWidth = $(window).width();
    }
})(MainActivity = MainActivity || {});
var MainActivity;
$(document).ready(function () {
    MainActivity.init();
    //remove focus for click    
    document.addEventListener('keydown', function (e) {
        if (e.keyCode === 9) {
            $('body').addClass('show-focus-outlines');
        }
    });
    document.addEventListener('click', function (e) {
        $('body').removeClass('show-focus-outlines');
    });

    setTimeout(function () {
        $('.next-nav-page a').attr('tabindex', '0');
        $('.prev-nav-page a').attr('tabindex', '0');
        $('.disabled, .disabled a').attr('tabindex', '-1');
        $('.next-nav-page').attr('tabindex', '-1');
        $('.prev-nav-page').attr('tabindex', '-1');
    }, 500);
    //alert($(window).innerHeight())

});
$(window).resize(function () {
    MainActivity.setParameters();
});